' reboot.vbs: reboot the computers given on the command line
'
' USAGE
'
'   reboot.vbs [COMPUTER [COMPUTER ...]]
'
'   COMPUTER	Name of computer to reboot
'
' NOTES
'
'   If no computers are specified on the command line, this
'   script reboots the local computer.
'

Option Explicit

Main()

Sub Main()

  ' If no command-line arguments are given, reboot the local
  ' computer; otherwise, reboot each computer in the list.
  '

  Dim objArguments
  Set objArguments = WScript.Arguments

  If objArguments.Count > 0 Then

    Dim strComputer
    For Each strComputer In objArguments
      Reboot( strComputer )
    Next

  Else

    Reboot( "." )

  End If

End Sub

Sub Reboot( strComputer )

  ' Reboot a computer:
  '
  '   strComputer	Name of computer to reboot
  '
  Dim objWMIService
  Dim colOperatingSystems
  Dim objOperatingSystem

  On Error Resume Next

  Set objWMIService = GetObject( "winmgmts:{impersonationLevel=impersonate,(Shutdown)}!\\" & strComputer & "\root\cimv2" )
  If Err.Number = 0 Then

    ' Attempt to reboot the computer only if a connection was made

    Set colOperatingSystems = objWMIService.InstancesOf( "Win32_OperatingSystem" )
    For Each objOperatingSystem in colOperatingSystems
      objOperatingSystem.Reboot()
    Next
  End If

End Sub